<template>
  <div id="app">

    <nav>
      <div class="nav-wrapper blue darken-1">
        <a href="#" class="brand-logo center">Metas</a>
      </div>
    </nav>

    <div class="container">

      <ul>
          <li v-for="(erro, index) of errors" :key="index"> 
              campo <b> {{ erro.field }} - {{ erro.defaultMessage }} </b>
          </li>
      </ul>

      <form @submit.prevent="salvar">

          <label>Título</label>
          <input type="text" placeholder="Titulo" v-model="meta.titulo">

          <label>Descrição</label>
          <input type="text" placeholder="Descrição" v-model="meta.descricao">

          <label>Valor inicial</label>
          <input type="text" placeholder="Valor inicial" v-model="meta.valorAtual">

          <label>Valor total</label>
          <input type="text" placeholder="Valor total" v-model="meta.valorTotal">

          <label>Data inicial</label>
          <input type="date" v-model="meta.dataInicial">

          <label>Data Final</label>
          <input type="date" meta.dataFinal>

          <button class="waves-effect waves-light btn-small">Salvar<i class="material-icons left">save</i></button>

      </form>

      <table>

        <thead>

          <tr>
            <th>TÍTULO</th>
            <th>DESCRIÇÃO</th>
            <th>VALOR ATUAL</th>
            <th>VALOR TOTAL</th>
            <th>DATA DE INICIO</th>
            <th>DATA FINAL DA META</th>
            <th>USUÁRIO</th>
          </tr>

        </thead>

        <tbody>

          <tr v-for="meta of metas" :key="meta.id">

            <td> {{ meta.titulo }} </td>
            <td> {{ meta.descricao }} </td>
            <td> {{ meta.valorAtual }} </td>
            <td> {{ meta.valorTotal }} </td>
            <td> {{ meta.dataInicial }} </td>
            <td> {{ meta.dataFinal }} </td>
            <td>
              <button @click="editar(meta)" class="waves-effect btn-small blue darken-1"><i class="material-icons">create</i></button>
              <button @click="remover(meta)" class="waves-effect btn-small red darken-1"><i class="material-icons">delete_sweep</i></button>
            </td>

          </tr>

        </tbody>
      
      </table>

    </div>

  </div>
</template>

<script>

import Meta from '../service/metas';

export default {

  data(){
    return {
      meta: {
        id: '',
        titulo: '',
        descricao: '',
        valorAtual: '',
        valorTotal: '',
        dataInicial: '',
        dataFinal: ''
      },

      metas: [],
      errors: []
    }
  },

  mounted(){
    Meta.listar().then(resposta => {
      this.listar()
    })
  },

  methods: {
    listar() {
      Meta.listar().then(resposta => {
        this.metas = resposta.data
      })
    },

    salvar () {
      if(!this.meta.id){
        Meta.salvar(this.meta).then(resposta => {
          this.meta = {}
          alert('Meta cadastrada com sucesso!')
          this.listar()
          this.errors = []
        }).catch(e => {
          this.errors = e.response.data.errors
      })
    }else{
      Meta.atualizar(this.meta).then(resposta => {
          this.meta = {}
          alert('Meta atualizada com sucesso!')
          this.listar()
          this.errors = []
        }).catch(e => {
          this.errors = e.response.data.errors
      })
    }

  },

  editar(meta){
    this.meta = meta
  },

  remover(meta){
    if(confirm('Deseja excluir essa meta?')){
      Meta.apagar(meta).then(resposta => {
        this.listar();
        this.errors = []
      }).catch(e => {
        this.errors = e.response.data.errors
      })
    }
  }
}
}

</script>